'GotoFunc for HomeSite 4.5.1
'Author: Corey Haines (corey@elender.hu)
'Description: 	This script is intended to mimic the Shift-F2 functionality in the Visual Basic IDE. 
'Basically, this will inspect the word around the cursor, and search for a function or sub that has that name. 
'It will then scroll the editor pane to	the beginning of that method. 
'It is pretty hacked together right now, as I don't have too much experience programming the editor, itself.</p>
'Updates:
'
' This script has been released to the public domain. If you make a change, please let me know, so I can add it,
' if necessary, to the original. You are free to distribute this script, as long as you leave this header in place.
'
option explicit

sub Main()
	dim doc
	dim sCurWord
	
	set doc = Application.ActiveDocument

	sCurWord = getCurrentWord(doc)

	if len(trim(sCurWord)) > 0 then
		moveToWord doc, sCurWord
	end if

	set doc = Nothing
end sub

sub moveToWord(doc, sWord)
	dim lTotLines
	dim lCurLine, sCurLine
	dim lLoc
	lLoc = 0
	lCurLine = 1
	lTotLines = doc.LineCount
	do until (lLoc > 0) or (lCurLine > lTotLines)
		sCurLine = doc.Lines(lCurLine)
		lLoc = Instr(1, sCurLine, sWord, 1)
		if lLoc > 0 then
			if instr(1, sCurLine, "function", 1) = 0 and instr(1, sCurLine, "sub", 1) = 0 then
				lLoc = 0
			end if
		end if
		lCurLine = lCurLine + 1
	loop
	if lLoc > 0 then
		doc.setCaretPos lLoc, lCurLine
		' for some reason, it sometimes doesn't scroll, so the next two lines force a scroll
		doc.CursorLeft false
		doc.CursorRight false
	end if
end sub

function getCurrentWord(doc)
	dim sCurWord
	dim bGotName
	dim sNext, sPrev

	sPrev = doc.getPreviousChar
	doc.cursorright false
	sNext = doc.getNextChar
	doc.cursorleft false

	select case true
	case asc(sPrev) = 13, asc(sPrev) = 9, len(trim(sPrev)) = 0
		'
	case asc(sNext) = 13, asc(sNext) = 9, len(trim(sNext)) = 0
		doc.cursorwordright false
	case else
		doc.cursorwordleft false
	end select
	bGotName = False
	sCurWord = ""
	do until bGotName
		select case true
		case asc(doc.getCurrentChar) = 13,asc(doc.getCurrentChar) = 9, len(trim(doc.getCurrentChar)) = 0
			bGotName = True
		case else
			sCurWord = sCurWord & doc.getCurrentChar
			doc.CursorRight false
		end select
	loop

	getCurrentWord = sCurWord
end function

